﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HeuristicLab.Problems.Instances.DataAnalysis.Regression.Matlab.Api.Types {
  public class MLDoubleArray : IMLValueVariable<double[,]> {

    public MLDoubleArray(string name, object values) {
      Name = name;
      if (!(values is double[,])) {
        throw new ArgumentException(string.Format("Invalid datatype for value: {0}", values.GetType()));
      }
      Data = values as double[,];
    }

    public string Name { get; set; }
    public double[,] Data { get; set; }

    public MLDatatype Datatype {
      get { return MLDatatype.DoubleArray; }
    }

    public IMLTimeseries ToTimeseries() {
      var times = new double[Data.GetLength(0), 1];
      for (int i = 0; i < times.GetLength(0); i++) {
        times[i, 1] = i;
      }

      return new MLTimeseries(Name, times, Data);
    }
  }


}
